pimbc(8)

NAME
pimbc - pimbd configuration and monitoring utility.

SYNOPSIS
pimbc [-s sock-path] [-v] [-d] [-t timeout] COMMAND

  COMMANDS
help link [ list | set ... ] rpa [ list | set ... | flush ... ] group [ list | set ... ] proxy [ list | set ... ] rib raw json-arguments file file-path

DESCRIPTION
pimbc is the companion configuration and monitoring utility of pimbd , a PIM-BIDIR dual stack implementation. It translates commands into json and sends them to pimbd through a unix socket. If pimbd returns an error message, or an json object, it is displayed.

OPTIONS

-s unix-socket-path
    Specify a custom unix socket IPC path. The default is /tmp/pimbd_ipc_server.sock.

-v  Specify whether the command should operate in verbose mode.

-d  Specify whether dry-run mode should be enabled. When enabled, syntax is checked but nothing is sent to pimbd. Note that this operation success does not ensure that sending the same command to pimbd would succeed as pimbd performs additional checks.

-t timeout
    Specify the timeout in seconds during which the IPC should keep trying to connect to pimbd. The default is 4.

COMMANDS

  help
Display help text.

  link link-commands
Display and configure interfaces.

list
    Dumps pimbd link information in json format.

set  dev  link-name options

    pim { on | off }
        Enable or disable PIM BIDIR on this interface.

    ssbidir { on | off }
        Enable or disable SSBIDIR on this interface. SSBIDIR enables source-specific multicast traffic filtering. This mode of operation is compatible with BIDIR-only routers.

    mld { on | off }
        Enable or disable MLDv2 querier on this interface.

    igmp { on | off }
        Enable or disable UGMPv3 querier on this interface.

    proxy { ADDRESS PORT | off }
        Enable or disable PIM Border Proxy on this interface. The ADDRESS and PORT determines the local address and port pimbd will listen to in order to receive proxy-controller incoming TCP connexions. Subscription state received from multiple proxy controllers is aggregated and translated into MLDv2 and IGMPv3 on the given interface. When multicast traffic is received on the interface, the proxy state is used to decide whether the traffic should be forwarded or not.

    hello TIME
        PIM Hello interval in seconds (or milliseconds if explicitly stated). The default value is 30 seconds. The dead neighbor detection delay is computed as '3.5 * hello_interval'.

    join TIME
        The PIM Join interval in seconds between two consecutive Joins (or in milliseconds if explicitly stated). The default value is 60 seconds.

    llqc NUMBER
        The MLDv2 and IGMPv3 Last Listener Query Count. The default value is 2.

    robustness NUMBER
        The MLDv2 and IGMPv3 robustness parameter. The default value is 2.

  group group-commands
Display and configure group states.

list
    Dumps pimbd group state in json format.

set group group-address [ dev link-name ] [ source source-address ] options

    listener { include | exclude | none }
        Configure multicast memberhsip on an interface. A device name must be specified. If a source address is set, the state is source-specific.

    local { include | exclude | none }
        Force local MLDv2 or IGMPv3 querier state. A device name must be specified. If a source address is set, the state is source-specific.

    pim { include | exclude | none }
        Force upstream PIM state to some specific state. The device name must not be set. If a source address is set, the state is source-specific.

  rpa rpa-commands
Display and configure rendez-vous point addresses.

list
    Dumps rendez-vous point state. That includes RPA mappings as well as per pim interface designated forwarder election state.

{ add | del } ADDRESS GROUP_PREFIX
    Add or deletes a rendez-vous point address to group prefix mapping. Designated forwarder election for a given RPA is automatically started when the RPA is associated with at least one group prefix.

flush ADDRESS
    Removes all mapped group prefixes for the given RPA.

set ADDRESS [ rpl_jp { on | off } ]
    Configures a given RPA. rpl_jp is, for now, the only option, and enables or disables sending Join/Prune messages on the RP Link.

  proxy proxy-commands
Configures proxy-controller behavior.

list
    Dumps the list of controlled proxies as well as their current status.

{ add | del } ADDRESS PORT
    Add or remove a PIM border proxy. All PIM upstream state is replicated to the PIM border proxy.

  raw JSON
Directly sends the provided JSON argument to pimb-ipc.

  file FILE-PATH
Reads the provided file line by line and pass those lines as arguments to pimbc (along with optional arguments). Empty lines and lines starting with '#' are ignored.

SEE ALSO
pimbd(8)

BUGS
Gotta catch'em all.

AUTHORS
Pierre Pfister (pierre at darou.fr)